diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index 3bb024159..53f8f7553 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -6,163 +6,161 @@ import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.BlockLogicVeryRotatable;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockLogicMotionSensor;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class TileEntitySensor extends TileEntity {
 
-	private int getSightRange(World world, double x, double y, double z, Direction facing) {
-		if(facing == Direction.NONE) {
-			return 0;
-		}
-		
-		int range = 4;
-		int blockInFront = world.getBlockId(MathHelper.round(x + facing.getOffsetX()), MathHelper.round(y + facing.getOffsetY()), MathHelper.round(z + facing.getOffsetZ()));
-		if(Blocks.hasTag(blockInFront, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
-			range = 8;
-		}
-		
-		for(int i = 1; i <= range; i++) {
-			int x1 = MathHelper.round(x + facing.getOffsetX() * i);
-			int y1 = MathHelper.round(y + facing.getOffsetY() * i);
-			int z1 = MathHelper.round(z + facing.getOffsetZ() * i);
-			int id = world.getBlockId(x1, y1, z1);
-			if(Blocks.solid[id] && !Blocks.hasTag(id, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
-				return i - 1;
-			}
-		}
-		
-		return range;
-	}
-
-	private AABB getDetectionBox(double x, double y, double z, Direction facing, int range) {
-		double x1 = x + facing.getOffsetX();
-		double y1 = y + facing.getOffsetY();
-		double z1 = z + facing.getOffsetZ();
-		
-		double x2 = x + facing.getOffsetX() * range;
-		double y2 = y + facing.getOffsetY() * range;
-		double z2 = z + facing.getOffsetZ() * range;
-		
-		double minX = Math.min(x1, x2);
-		double minY = Math.min(y1, y2);
-		double minZ = Math.min(z1, z2);
-		
-		double maxX = Math.max(x1, x2) + 1;
-		double maxY = Math.max(y1, y2) + 1;
-		double maxZ = Math.max(z1, z2) + 1;
-		
-		return AABB.fromPool(minX, minY, minZ, maxX, maxY, maxZ);
-	}
-
-	@Override
-	public void tick() {
-		if(worldObj == null || worldObj.isClientSide) {
-			return;
-		}
-		
-		int id = worldObj.getBlockId(x, y, z);
-		int meta = worldObj.getBlockMetadata(x, y, z);
-		
-		boolean shouldBeActive = false;
-		Direction facing = BlockLogicVeryRotatable.metaToDirection(meta);
-		int effectiveRange = getSightRange(worldObj, x, y, z, facing);
-		if(effectiveRange > 0) {
-			AABB detectionBox = getDetectionBox(x, y, z, facing, effectiveRange);
-			List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(null, detectionBox);
-			for(int i=0; i < list.size(); i++) {
-				Entity entity = list.get(i);
-				if (entity.canInteract()) {
-					if(entity instanceof Player) {
-						Player player = (Player) entity;
-						player.triggerAchievement(Achievements.GET_SENSED);
-					}
-					shouldBeActive = true;
-				}
-			}
-		}
-		
-		if(shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id()) {
-			worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5, y + 0.5, z + 0.5, "tile.sensor_block.sense", 1f, worldObj.rand.nextFloat());
-			updateSensorBlockState(true, worldObj);
-		}
-		if(!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id()) {
-			updateSensorBlockState(false, worldObj);
-		}
-	}
-
-	@Override
-	public void readAdditionalData(@NotNull CompoundTag compoundTag) {
-
-	}
-
-	@Override
-	public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
-
-	}
-
-	@Override
-	public void heldTick(World world, Entity holder) {
-		if(world == null || carriedBlock == null || world.isClientSide) {
-			return;
-		}
-		assert worldObj == null;
-
-		int id = carriedBlock.blockId;
-		int meta = carriedBlock.metadata;
-
-		boolean shouldBeActive = false;
-		Direction facing = BlockLogicVeryRotatable.metaToDirection(meta);
-		int effectiveRange = getSightRange(world, holder.x, holder.y, holder.z, facing);
-		if(effectiveRange > 0) {
-			AABB detectionBox = getDetectionBox(holder.x, holder.y, holder.z, facing, effectiveRange);
-			List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(null, detectionBox);
-			for(int i=0; i < list.size(); i++) {
-				Entity entity = list.get(i);
-				if (entity == holder) continue;
-				if(entity instanceof Player) {
-					Player player = (Player) entity;
-					player.triggerAchievement(Achievements.GET_SENSED);
-				}
-				shouldBeActive = true;
-			}
-		}
-
-		if(shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id()) {
-			world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5, y + 0.5, z + 0.5, "tile.sensor_block.sense", 1f, world.rand.nextFloat());
-			updateSensorBlockState(true, world);
-		}
-		if(!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id()) {
-			updateSensorBlockState(false, world);
-		}
-	}
-
-	public void updateSensorBlockState(boolean active, World world) {
-		if (carriedBlock != null) {
-            if(active) {
-				carriedBlock.blockId = Blocks.MOTION_SENSOR_ACTIVE.id();
-			}else {
-				carriedBlock.blockId = Blocks.MOTION_SENSOR_IDLE.id();
-			}
-		} else {
-			int meta = world.getBlockMetadata(x, y, z);
-			int blockId;
-			if(active) {
-				blockId = Blocks.MOTION_SENSOR_ACTIVE.id();
-			}else {
-				blockId = Blocks.MOTION_SENSOR_IDLE.id();
-			}
-			world.setBlock(x, y, z, blockId);
-			world.setBlockMetadata(x, y, z, meta);
-			world.notifyBlockChange(x, y, z, blockId);
-		}
-	}
+    private int getSightRange(World world, double x, double y, double z, Direction facing) {
+        if (facing == Direction.NONE) {
+            return 0;
+        }
+
+        int range = 4;
+        int blockInFront = world.getBlockId(MathHelper.round(x + facing.getOffsetX()), MathHelper.round(y + facing.getOffsetY()), MathHelper.round(z + facing.getOffsetZ()));
+        if (Blocks.hasTag(blockInFront, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
+            range = 8;
+        }
+
+        for (int i = 1; i <= range; i++) {
+            int x1 = MathHelper.round(x + facing.getOffsetX() * i);
+            int y1 = MathHelper.round(y + facing.getOffsetY() * i);
+            int z1 = MathHelper.round(z + facing.getOffsetZ() * i);
+            int id = world.getBlockId(x1, y1, z1);
+            if (Blocks.solid[id] && !Blocks.hasTag(id, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
+                return i - 1;
+            }
+        }
+
+        return range;
+    }
+
+    private @NotNull AABBdc getDetectionBox(double x, double y, double z, @NotNull Direction facing, int range) {
+        double x1 = x + facing.getOffsetX();
+        double y1 = y + facing.getOffsetY();
+        double z1 = z + facing.getOffsetZ();
+
+        double x2 = x + facing.getOffsetX() * range;
+        double y2 = y + facing.getOffsetY() * range;
+        double z2 = z + facing.getOffsetZ() * range;
+
+        double minX = Math.min(x1, x2);
+        double minY = Math.min(y1, y2);
+        double minZ = Math.min(z1, z2);
+
+        double maxX = Math.max(x1, x2) + 1;
+        double maxY = Math.max(y1, y2) + 1;
+        double maxZ = Math.max(z1, z2) + 1;
+
+        return new AABBd(minX, minY, minZ, maxX, maxY, maxZ);
+    }
+
+    @Override
+    public void tick() {
+        if (this.worldObj == null || this.worldObj.isClientSide) {
+            return;
+        }
+
+        int id = this.worldObj.getBlockId(this.x, this.y, this.z);
+        int meta = this.worldObj.getBlockMetadata(this.x, this.y, this.z);
+
+        boolean shouldBeActive = false;
+        Direction facing = BlockLogicVeryRotatable.metaToDirection(meta);
+        int effectiveRange = getSightRange(this.worldObj, this.x, this.y, this.z, facing);
+        if (effectiveRange > 0) {
+            AABBdc detectionBox = getDetectionBox(this.x, this.y, this.z, facing, effectiveRange);
+            List<Entity> list = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, detectionBox);
+            for (int i = 0; i < list.size(); i++) {
+                Entity entity = list.get(i);
+                if (entity.canInteract()) {
+                    if (entity instanceof Player player) {
+                        player.triggerAchievement(Achievements.GET_SENSED);
+                    }
+                    shouldBeActive = true;
+                }
+            }
+        }
+
+        if (shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id()) {
+            this.worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, this.x + 0.5, this.y + 0.5, this.z + 0.5, "tile.sensor_block.sense", 1f, this.worldObj.rand.nextFloat());
+            updateSensorBlockState(true, this.worldObj);
+        }
+        if (!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id()) {
+            updateSensorBlockState(false, this.worldObj);
+        }
+    }
+
+    @Override
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+
+    }
+
+    @Override
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
+
+    }
+
+    @Override
+    public void heldTick(World world, Entity holder) {
+        if (world == null || this.carriedBlock == null || world.isClientSide) {
+            return;
+        }
+        assert this.worldObj == null;
+
+        int id = this.carriedBlock.blockId;
+        int meta = this.carriedBlock.metadata;
+
+        boolean shouldBeActive = false;
+        Direction facing = BlockLogicVeryRotatable.metaToDirection(meta);
+        int effectiveRange = getSightRange(world, holder.x, holder.y, holder.z, facing);
+        if (effectiveRange > 0) {
+            AABBdc detectionBox = getDetectionBox(holder.x, holder.y, holder.z, facing, effectiveRange);
+            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(null, detectionBox);
+            for (int i = 0; i < list.size(); i++) {
+                Entity entity = list.get(i);
+                if (entity == holder) continue;
+                if (entity instanceof Player player) {
+                    player.triggerAchievement(Achievements.GET_SENSED);
+                }
+                shouldBeActive = true;
+            }
+        }
+
+        if (shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id()) {
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, this.x + 0.5, this.y + 0.5, this.z + 0.5, "tile.sensor_block.sense", 1f, world.rand.nextFloat());
+            updateSensorBlockState(true, world);
+        }
+        if (!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id()) {
+            updateSensorBlockState(false, world);
+        }
+    }
+
+    public void updateSensorBlockState(boolean active, World world) {
+        if (this.carriedBlock != null) {
+            if (active) {
+                this.carriedBlock.blockId = Blocks.MOTION_SENSOR_ACTIVE.id();
+            } else {
+                this.carriedBlock.blockId = Blocks.MOTION_SENSOR_IDLE.id();
+            }
+        } else {
+            int meta = world.getBlockMetadata(this.x, this.y, this.z);
+            int blockId;
+            if (active) {
+                blockId = Blocks.MOTION_SENSOR_ACTIVE.id();
+            } else {
+                blockId = Blocks.MOTION_SENSOR_IDLE.id();
+            }
+            world.setBlock(this.x, this.y, this.z, blockId);
+            world.setBlockMetadata(this.x, this.y, this.z, meta);
+            world.notifyBlockChange(this.x, this.y, this.z, blockId);
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/logic/RailDirection.java b/game/core/src/main/java/net/minecraft/core/block/logic/RailDirection.java
index 6a74552d2..5cf2e5891 100644
--- a/game/core/src/main/java/net/minecraft/core/block/logic/RailDirection.java
+++ b/game/core/src/main/java/net/minecraft/core/block/logic/RailDirection.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.logic;
 
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public enum RailDirection {
@@ -43,6 +44,7 @@ public enum RailDirection {
     static {
         directionMap = new RailDirection[TURN_EN.meta + 1];
         for (RailDirection d : values()){
+            if (d.meta < 0) continue;
             directionMap[d.meta] = d;
         }
     }
@@ -73,12 +75,12 @@ public enum RailDirection {
         this.offZ2 = offZ2;
     }
 
-    public @NotNull TilePos getNextRail(@NotNull TilePos curPos) {
-        return curPos.add(this.offX1, this.offY1, this.offZ1);
+    public @NotNull TilePos getNextRail(@NotNull TilePosc curPos, @NotNull TilePos dest) {
+        return curPos.add(this.offX1, this.offY1, this.offZ1, dest);
     }
 
-    public @NotNull TilePos getPrevRail(@NotNull TilePos curPos) {
-        return curPos.add(this.offX2, this.offY2, this.offZ2);
+    public @NotNull TilePos getPrevRail(@NotNull TilePosc curPos, @NotNull TilePos dest) {
+        return curPos.add(this.offX2, this.offY2, this.offZ2, dest);
     }
     public boolean isSloped(){
         return this.sloped;
diff --git a/game/core/src/main/java/net/minecraft/core/block/material/Material.java b/game/core/src/main/java/net/minecraft/core/block/material/Material.java
index d46fa1686..b5a2067eb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/material/Material.java
+++ b/game/core/src/main/java/net/minecraft/core/block/material/Material.java
@@ -1,7 +1,8 @@
 package net.minecraft.core.block.material;
 
-public class Material
-{
+import org.jetbrains.annotations.NotNull;
+
+public class Material {
     public static final int PISTON_PUSHABLE = 0;
     public static final int PISTON_DESTROY_ON_PUSH = 1;
     public static final int PISTON_CANT_PUSH = 2;
@@ -11,175 +12,116 @@ public class Material
     public static final int LIGHTNING_LIGHT_CONDUCTOR = 5;
     public static final int LIGHTNING_LIGHT_INSULATOR = -5;
     public static final int LIGHTNING_STRONG_INSULATOR = -20;
+
     private boolean flammable;
     private boolean replaceable;
     private boolean notSolidBlocking;
-    public final MaterialColor color;
+    public final @NotNull MaterialColor color;
     private boolean alwaysDestroyable;
     private boolean isStone;
     private boolean isMetal;
     private int pushReaction = PISTON_PUSHABLE;
     private int lightningConductivity = LIGHTNING_NEUTRAL;
 
-    public Material(MaterialColor color)
-    {
-        alwaysDestroyable = true;
+    public Material(final @NotNull MaterialColor color) {
+        this.alwaysDestroyable = true;
         this.color = color;
     }
 
-    public boolean isLiquid()
-    {
+    public boolean isLiquid() {
         return false;
     }
 
-    public boolean isSolid()
-    {
+    public boolean isSolid() {
         return true;
     }
 
-    public boolean blocksLight()
-    {
+    public boolean blocksLight() {
         return true;
     }
 
-    public boolean blocksMotion()
-    {
+    public boolean blocksMotion() {
         return true;
     }
 
-    public Material setAsStone() {
-        isStone = true;
+    public @NotNull Material setAsStone() {
+        this.isStone = true;
         return this;
     }
 
-    public boolean isStone() { return isStone; }
+    public boolean isStone() {
+        return this.isStone;
+    }
 
-    public Material setAsMetal() {
-        isMetal = true;
+    public @NotNull Material setAsMetal() {
+        this.isMetal = true;
         return this;
     }
 
     public boolean isMetal() {
-        return isMetal;
+        return this.isMetal;
     }
 
-    public Material notSolidBlocking()
-    {
-        notSolidBlocking = true;
+    public @NotNull Material notSolidBlocking() {
+        this.notSolidBlocking = true;
         return this;
     }
 
-    public Material notAlwaysDestroyable()
-    {
-        alwaysDestroyable = false;
+    public @NotNull Material notAlwaysDestroyable() {
+        this.alwaysDestroyable = false;
         return this;
     }
 
-    public Material flammable()
-    {
-        flammable = true;
+    public @NotNull Material flammable() {
+        this.flammable = true;
         return this;
     }
 
-    public boolean isFlammable()
-    {
-        return flammable;
+    public boolean isFlammable() {
+        return this.flammable;
     }
 
-    public Material replaceable()
-    {
-        replaceable = true;
+    public @NotNull Material replaceable() {
+        this.replaceable = true;
         return this;
     }
 
-    public boolean isReplaceable()
-    {
-        return replaceable;
+    public boolean isReplaceable() {
+        return this.replaceable;
     }
 
-    public boolean isSolidBlocking()
-    {
-        if (notSolidBlocking)
-        {
+    public boolean isSolidBlocking() {
+        if (this.notSolidBlocking) {
             return false;
-        }
-        else
-        {
-            return blocksMotion();
+        } else {
+            return this.blocksMotion();
         }
     }
 
-    public boolean isAlwaysDestroyable()
-    {
-        return alwaysDestroyable;
+    public boolean isAlwaysDestroyable() {
+        return this.alwaysDestroyable;
     }
 
-    public int getPushReaction()
-    {
-        return pushReaction;
+    public int getPushReaction() {
+        return this.pushReaction;
     }
 
-    public Material destroyOnPush()
-    {
-        pushReaction = PISTON_DESTROY_ON_PUSH;
+    public @NotNull Material destroyOnPush() {
+        this.pushReaction = PISTON_DESTROY_ON_PUSH;
         return this;
     }
 
-    public Material notPushable()
-    {
-        pushReaction = PISTON_CANT_PUSH;
+    public @NotNull Material notPushable() {
+        this.pushReaction = PISTON_CANT_PUSH;
         return this;
     }
-    public int getConductivity(){
-        return lightningConductivity;
+
+    public int getConductivity() {
+        return this.lightningConductivity;
     }
-    public Material setConductivity(int conductivity){
-        lightningConductivity = conductivity;
+
+    public @NotNull Material setConductivity(final int conductivity) {
+        this.lightningConductivity = conductivity;
         return this;
     }
-
-
-    public static final Material air = new MaterialGas(MaterialColor.none);
-    public static final Material grass = new Material(MaterialColor.grass);
-    public static final Material dirt = new Material(MaterialColor.dirt);
-    public static final Material wood = new Material(MaterialColor.wood).flammable();
-
-    public static final Material stone = new Material(MaterialColor.stone).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
-    public static final Material basalt = new Material(MaterialColor.basalt).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
-    public static final Material limestone = new Material(MaterialColor.limestone).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
-    public static final Material granite = new Material(MaterialColor.granite).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
-    public static final Material permafrost = new Material(MaterialColor.permafrost).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
-    public static final Material marble = new Material(MaterialColor.marble).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
-    public static final Material slate = new Material(MaterialColor.slate).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
-    public static final Material netherrack = new Material(MaterialColor.netherrack).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
-
-    public static final Material metal = new Material(MaterialColor.metal).setConductivity(LIGHTNING_STRONG_CONDUCTOR).setAsMetal().notAlwaysDestroyable();
-    public static final Material steel = new Material(MaterialColor.steel).setConductivity(LIGHTNING_STRONG_CONDUCTOR).setAsMetal().notAlwaysDestroyable();
-    public static final Material water = new MaterialLiquid(MaterialColor.water).setConductivity(LIGHTNING_LIGHT_CONDUCTOR).destroyOnPush();
-    public static final Material lava = new MaterialLiquid(MaterialColor.fire).destroyOnPush();
-    public static final Material leaves = new Material(MaterialColor.plant).flammable().notSolidBlocking().destroyOnPush();
-    public static final Material plant = new MaterialDecoration(MaterialColor.plant).destroyOnPush().replaceable();
-    public static final Material sponge = new Material(MaterialColor.wool);
-    public static final Material cloth = new Material(MaterialColor.wool).flammable();
-    public static final Material fire = new MaterialGas(MaterialColor.none).destroyOnPush();
-    public static final Material sand = new Material(MaterialColor.sand);
-    public static final Material soulsand = new Material(MaterialColor.paintedBrown);
-    public static final Material decoration = new MaterialDecoration(MaterialColor.none).destroyOnPush();
-    public static final Material glass = new Material(MaterialColor.none).setConductivity(LIGHTNING_STRONG_INSULATOR).notSolidBlocking();
-    public static final Material explosive = new Material(MaterialColor.fire).flammable().notSolidBlocking();
-    public static final Material coral = new Material(MaterialColor.plant).destroyOnPush();
-    public static final Material ice = new Material(MaterialColor.ice).notSolidBlocking();
-    public static final Material topSnow = new MaterialDecoration(MaterialColor.snow).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
-    public static final Material snow = new Material(MaterialColor.snow).notAlwaysDestroyable();
-    public static final Material topAsh = new MaterialDecoration(MaterialColor.snow).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
-    public static final Material ash = new Material(MaterialColor.snow).notAlwaysDestroyable();
-    public static final Material cactus = new Material(MaterialColor.plant).notSolidBlocking().destroyOnPush();
-    public static final Material clay = new Material(MaterialColor.clay);
-    public static final Material vegetable = new Material(MaterialColor.plant).destroyOnPush();
-    public static final Material portal = new MaterialPortal(MaterialColor.none).notPushable();
-    public static final Material cake = new Material(MaterialColor.none).destroyOnPush();
-    public static final Material web = new Material(MaterialColor.wool).notAlwaysDestroyable().destroyOnPush();
-    public static final Material piston = new Material(MaterialColor.stone);
-    public static final Material moss = new Material(MaterialColor.grass).flammable().notAlwaysDestroyable();
-    public static final Material woodWet = (new Material(MaterialColor.grass).setConductivity(LIGHTNING_LIGHT_CONDUCTOR));
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/material/Materials.java b/game/core/src/main/java/net/minecraft/core/block/material/Materials.java
new file mode 100644
index 000000000..0ccf6a964
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/material/Materials.java
@@ -0,0 +1,49 @@
+package net.minecraft.core.block.material;
+
+import org.jetbrains.annotations.NotNull;
+
+public final class Materials {
+    public static final @NotNull Material AIR = new MaterialGas(MaterialColor.none);
+    public static final @NotNull Material GRASS = new Material(MaterialColor.grass);
+    public static final @NotNull Material DIRT = new Material(MaterialColor.dirt);
+    public static final @NotNull Material WOOD = new Material(MaterialColor.wood).flammable();
+    public static final @NotNull Material STONE = new Material(MaterialColor.stone).setConductivity(Material.LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final @NotNull Material BASALT = new Material(MaterialColor.basalt).setConductivity(Material.LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final @NotNull Material LIMESTONE = new Material(MaterialColor.limestone).setConductivity(Material.LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final @NotNull Material GRANITE = new Material(MaterialColor.granite).setConductivity(Material.LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final @NotNull Material PERMAFROST = new Material(MaterialColor.permafrost).setConductivity(Material.LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final @NotNull Material MARBLE = new Material(MaterialColor.marble).setConductivity(Material.LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final @NotNull Material SLATE = new Material(MaterialColor.slate).setConductivity(Material.LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final @NotNull Material NETHERRACK = new Material(MaterialColor.netherrack).setConductivity(Material.LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final @NotNull Material METAL = new Material(MaterialColor.metal).setConductivity(Material.LIGHTNING_STRONG_CONDUCTOR).setAsMetal().notAlwaysDestroyable();
+    public static final @NotNull Material STEEL = new Material(MaterialColor.steel).setConductivity(Material.LIGHTNING_STRONG_CONDUCTOR).setAsMetal().notAlwaysDestroyable();
+    public static final @NotNull Material WATER = new MaterialLiquid(MaterialColor.water).setConductivity(Material.LIGHTNING_LIGHT_CONDUCTOR).destroyOnPush();
+    public static final @NotNull Material LAVA = new MaterialLiquid(MaterialColor.fire).destroyOnPush();
+    public static final @NotNull Material LEAVES = new Material(MaterialColor.plant).flammable().notSolidBlocking().destroyOnPush();
+    public static final @NotNull Material PLANT = new MaterialDecoration(MaterialColor.plant).destroyOnPush().replaceable();
+    public static final @NotNull Material SPONGE = new Material(MaterialColor.wool);
+    public static final @NotNull Material CLOTH = new Material(MaterialColor.wool).flammable();
+    public static final @NotNull Material FIRE = new MaterialGas(MaterialColor.none).destroyOnPush();
+    public static final @NotNull Material SAND = new Material(MaterialColor.sand);
+    public static final @NotNull Material SOUL_SAND = new Material(MaterialColor.paintedBrown);
+    public static final @NotNull Material DECORATION = new MaterialDecoration(MaterialColor.none).destroyOnPush();
+    public static final @NotNull Material GLASS = new Material(MaterialColor.none).setConductivity(Material.LIGHTNING_STRONG_INSULATOR).notSolidBlocking();
+    public static final @NotNull Material EXPLOSIVE = new Material(MaterialColor.fire).flammable().notSolidBlocking();
+    public static final @NotNull Material CORAL = new Material(MaterialColor.plant).destroyOnPush();
+    public static final @NotNull Material ICE = new Material(MaterialColor.ice).notSolidBlocking();
+    public static final @NotNull Material TOP_SNOW = new MaterialDecoration(MaterialColor.snow).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
+    public static final @NotNull Material SNOW = new Material(MaterialColor.snow).notAlwaysDestroyable();
+    public static final @NotNull Material TOP_ASH = new MaterialDecoration(MaterialColor.snow).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
+    public static final @NotNull Material ASH = new Material(MaterialColor.snow).notAlwaysDestroyable();
+    public static final @NotNull Material CACTUS = new Material(MaterialColor.plant).notSolidBlocking().destroyOnPush();
+    public static final @NotNull Material CLAY = new Material(MaterialColor.clay);
+    public static final @NotNull Material VEGETABLE = new Material(MaterialColor.plant).destroyOnPush();
+    public static final @NotNull Material PORTAL = new MaterialPortal(MaterialColor.none).notPushable();
+    public static final @NotNull Material CAKE = new Material(MaterialColor.none).destroyOnPush();
+    public static final @NotNull Material WEB = new Material(MaterialColor.wool).notAlwaysDestroyable().destroyOnPush();
+    public static final @NotNull Material PISTON = new Material(MaterialColor.stone);
+    public static final @NotNull Material MOSS = new Material(MaterialColor.grass).flammable().notAlwaysDestroyable();
+    public static final @NotNull Material WOOD_WET = (new Material(MaterialColor.grass).setConductivity(Material.LIGHTNING_LIGHT_CONDUCTOR));
+
+    private Materials() { }
+}
